import React, { useState, useEffect } from 'react';
import Menu from '@mui/material/Menu';
import MenuItem from '@mui/material/MenuItem';

interface IProps {
  contextData: any;
  onSetContextData: (contextData: any) => void;
}

const ContextMenu: React.FC<IProps> = props => {
  const { contextData, onSetContextData } = props;

  const [contextMenu, setContextMenu] = useState<{
    mouseX: number;
    mouseY: number;
  } | null>(null);

  useEffect(() => {
    setContextMenu(contextData);
  }, [contextData]);

  // 关闭右键菜单
  const handleClose = () => {
    setContextMenu(null);
  };

  // 执行此处
  const handleRun = () => {
    setContextMenu(null);
    handleSetcontextData;
  };
  // 执行到此处
  const handleRunEndHere = () => {
    setContextMenu(null);
    handleSetcontextData;
  };
  // 从此处开始执行
  const handleRunBeginHere = () => {
    setContextMenu(null);
    handleSetcontextData;
  };
  const handleSetcontextData = () => {
    console.log(onSetContextData);
    onSetContextData(null);
  };

  return (
    <Menu
      open={contextMenu !== null}
      onClose={handleClose}
      anchorReference="anchorPosition"
      anchorPosition={
        contextMenu !== null
          ? {
              top: contextMenu.mouseY,
              left: contextMenu.mouseX
            }
          : undefined
      }
    >
      <MenuItem onClick={handleRun}>执行</MenuItem>
      <MenuItem onClick={handleRunEndHere}>执行到此处</MenuItem>
      <MenuItem onClick={handleRunBeginHere}>从此处开始执行</MenuItem>
    </Menu>
  );
};

export default ContextMenu;
